﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Problems.DataAnalysis.Transformations;

namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
  public class TransformationToSymbolicTreeMapper : ITransformationMapper<ISymbolicExpressionTree> {
    #region ITransformationMapper<ISymbolicExpressionTree> Members

    public ISymbolicExpressionTree GenerateModel(ITransformation transformation) {
      var tree = CreateNewTree();
      var column = transformation.Column;

      if (transformation is LinearTransformation) {
        var kValue = ((LinearTransformation)transformation).Multiplier;
        var multiplicationNode = new Multiplication().CreateTreeNode();
        var kNode = new Constant();
      } else if (transformation is ExponentialTransformation) {

      } else if (transformation is LogarithmicTransformation) {

      } else if (transformation is PowerTransformation) {

      } else if (transformation is ReciprocalTransformation) {

      } else if (transformation is ShiftStandardDistributionTransformation) {

      }

      //var variableNode = (VariableTreeNode)new Variable("dummy", "dummy description").CreateTreeNode();
      //variableNode.VariableName = "dummy";
      //tree.Root.AddSubtree(variableNode);

      return tree;
    }

    public ISymbolicExpressionTree GenerateInverseModel(ITransformation transformation) {
      var tree = CreateNewTree();
      var column = transformation.Column;

      if (transformation is LinearTransformation) {

      } else if (transformation is ExponentialTransformation) {

      } else if (transformation is LogarithmicTransformation) {

      } else if (transformation is PowerTransformation) {

      } else if (transformation is ReciprocalTransformation) {

      } else if (transformation is ShiftStandardDistributionTransformation) {

      }

      return tree;
    }

    #endregion

    private ISymbolicExpressionTree CreateNewTree() {
      return new SymbolicExpressionTree(new ProgramRootSymbol().CreateTreeNode());
    }
  }
}
